// TKOLmdvLZH -  .  LZH.
// :    ~BP7.    ,       ~8.
//   Delphi   KOL  .
// E-Mail: dominiko-m@yandex.ru
// http://www.mdvkol.narod.ru/

// -  -

// : 1.00 (04.10.2004)

unit KOLmdvLZH;
interface

uses Windows, KOL;

const
  MaxBuf = 4096;
  F		= 60;
  THRESHOLD	= 2;
  N_CHAR   =	(256 - THRESHOLD + F);
  T 	   =	(N_CHAR * 2 - 1);
  R 	   =	(T - 1);
  MAX_Freq =	$8000;

type
  PBuff = ^TBuff;
  TBuff = array[1..MaxBuf] of Byte;
  PFreq = ^TFreq;
  TFreq = array[0..T] of Word;
  PPntr = ^TPntr;
  TPntr = array[0..Pred(T+N_Char)] of SmallInt;
  PSon = ^TSon;
  TSon = array[0..Pred(T)] of SmallInt;
  PTextBuf = ^TTextBuf;
  TTextBuf = array[0..MaxBuf+F-2] of Byte;
  PWordRay = ^TWordRay;
  TWordRay = array[0..MaxBuf] of SmallInt;
  PBWordRay = ^TBWordRay;
  TBWordRay = array[0..MaxBuf+256] of SmallInt;

  TMoveBlock = function (var ABuff; ACount: Dword): Dword of object;

   {$ifdef F_P}
   TmdvLZH = class;
   PmdvLZH = TmdvLZH;
   TKOLmdvLZH = PmdvLZH;
   TmdvLZH = class(TObj)
   {$else}
   PmdvLZH = ^TmdvLZH;
   TKOLmdvLZH = PmdvLZH;
   TmdvLZH = object(TObj)
   {$endif}

  private
    FSource, FDestination: PStream;
    p_len, p_code: array[0..63] of Byte;
    d_code, d_len: array [0..255] of Byte;
    PosnG: Word;
    Buf: integer;
    PosnP: Word;
    GetBuf: Word;
    GetLen: Byte;
    PutBuf: Word;
    PutLen: Byte;
    CodeSize: LongInt;
    Match_Position: SmallInt;
    Match_Length: SmallInt;

    Text_Buf: PTextBuf;
    lSon, Dad: PWordRay;
    rSon: PBWordRay;
    Freq: PFreq;
    Prnt: PPntr;
    Son: PSon;
    InBuf, OutBuf: PBuff;

    FReadData: TMoveBlock;
    FWriteData: TMoveBlock;

    procedure InitLZH;
    procedure EndLZH;
    procedure Reconst;
    procedure StartHuff;
    procedure InsertNode(r: SmallInt);
    procedure DeleteNode(p: SmallInt);
    procedure EncodeChar(c: Word);
    function DecodeChar: SmallInt;
    procedure EncodePosition(c: Word);
    function DecodePosition: Word;
    procedure GetBlock(var Target; var Actual_Bytes: Word);
    procedure PutBlock(var Source; NoBytes: Word; var Actual_Bytes: Word);
    function GetBit: SmallInt;
    function GetByte: SmallInt;
    procedure PutCode(l: SmallInt; c: Word);
    procedure Update(c: SmallInt);

    function ReadBlockStream(var ABuff; ACount: Dword): Dword;
    function WriteBlockStream(var ABuff; ACount: Dword): Dword;
  public
    procedure LZHPack;
    procedure LZHUnpack(AUnpackSize: DWord);

    property ReadData: TMoveBlock read FReadData write FReadData;
    property WriteData: TMoveBlock read FWriteData write FWriteData;
  end;

function NewmdvLZH(AReadData, WriteData: TMoveBlock): TKOlmdvLZH;

procedure LZHPackStream(ASource, ADestination: PStream);
procedure LZHUnpackStream(ASource, ADestination: PStream; AUnpackCount: Integer);

procedure LZHPackFile(ASource, ADestination: String);
procedure LZHUnpackFile(ASource, ADestination: String);

implementation

function NewmdvLZH(AReadData, WriteData: TMoveBlock): TKOlmdvLZH;
begin
  {$ifdef F_P}
  Result:=PmdvLZH.Create;
  {$else}
  New(Result, Create);
  {$endif}
end;

procedure LZHPackStream(ASource, ADestination: PStream);
var LZH: TKOlmdvLZH;
begin
    LZH:= NewmdvLZH(nil, nil);
    LZH.FSource:= ASource; LZH.FDestination:=ADestination;
    LZH.ReadData:= LZH.ReadBlockStream;
    LZH.WriteData:= LZH.WriteBlockStream;
    LZH.LZHPack;
    LZH.Free;
end;

procedure LZHUnpackStream(ASource, ADestination: PStream; AUnpackCount: Integer);
var LZH: TKOlmdvLZH;
begin
    LZH:= NewmdvLZH(nil, nil);
    LZH.FSource:= ASource; LZH.FDestination:=ADestination;
    LZH.ReadData:= LZH.ReadBlockStream;
    LZH.WriteData:= LZH.WriteBlockStream;
    LZH.LZHUnpack(AUnpackCount);
    LZH.Free;
end;

procedure LZHPackFile(ASource, ADestination: String);
var SourceStream, DestinationStream: PStream;
    L: DWord;
begin
    SourceStream:= NewReadFileStream(ASource);
    DestinationStream:= NewWriteFileStream(ADestination); DestinationStream.Size:= 0;
    L:= SourceStream.Size; DestinationStream.Write(L, SizeOf(L));
    LZHPackStream(SourceStream, DestinationStream);
    SourceStream.Free; DestinationStream.Free;
end;

procedure LZHUnpackFile(ASource, ADestination: String);
var SourceStream, DestinationStream: PStream;
    L: DWord;
begin
    SourceStream:= NewReadFileStream(ASource);
    DestinationStream:= NewWriteFileStream(ADestination); DestinationStream.Size:= 0;
    SourceStream.Read(L, SizeOf(L));
    LZHUnpackStream(SourceStream, DestinationStream, L);
    SourceStream.Free; DestinationStream.Free;
end;

procedure TmdvLZH.InitLZH;
var i, k, n: Integer;
begin
    k:= 0;
    for i:= 0 to 63 do begin
      case i of
        1:      p_code[i]:= $20;
        2.. 4:  p_code[i]:= p_code[i-1]+$10;
        5.. 12: p_code[i]:= p_code[i-1]+$08;
        13..24: p_code[i]:= p_code[i-1]+$04;
        25..48: p_code[i]:= p_code[i-1]+$02;
        49..63: p_code[i]:= p_code[i-1]+$01;
        else p_code[i]:= 0;
      end;

      case i of
        1 .. 3: begin p_len[i]:= $4; n:= 16; end;
        4 ..11: begin p_len[i]:= $5; n:= 8; end;
        12..23: begin p_len[i]:= $6; n:= 4; end;
        24..47: begin p_len[i]:= $7; n:= 2; end;
        48..63: begin p_len[i]:= $8; n:= 1; end;
        else begin p_len[i]:= $3; n:= 32; end;
      end;
      FillMemory(@(d_code[k]), n, i);
      inc(k, n);
    end;

    for i:= 0 to 255 do begin
      case i of
        0  .. 31: d_len[i]:=$3; //32
        32 .. 79: d_len[i]:=$4; //48
        80 ..143: d_len[i]:=$5; //64
        144..191: d_len[i]:=$6; //48
        192..239: d_len[i]:=$7; //48
        240..255: d_len[i]:=$8; //16
      end;
    end;
    GetBuf:= 0; GetLen:= 0;
    PutLen:= 0; PutBuf:= 0;
    CodeSize:= 0;
    Match_Position:= 0; Match_Length:= 0;
    PosnG:= 1;
    Buf:= 0;
    PosnP:= 1;
    New(lSon); New(Dad); New(rSon); New(Text_Buf); New(Freq); New(Prnt); New(Son); New(InBuf); New(OutBuf);
end;

procedure TmdvLZH.EndLZH;
begin
    Dispose(Son);
    Dispose(Prnt);
    Dispose(Freq);
    Dispose(Text_Buf);
    Dispose(rSon);
    Dispose(Dad);
    Dispose(lSon);
    Dispose(OutBuf);
    Dispose(InBuf);
end;

procedure TmdvLZH.LZHPack;
var ct: Byte;
    i, len, r, s, last_match_length: SmallInt;
    Got: Word;
begin
    InitLZH;
    StartHuff;
    for i:= MaxBuf + 1 TO MaxBuf + 256 do rSon^[i]:= MaxBuf;
    for i:= 0 to MaxBuf do Dad^[i]:= MaxBuf;

    s:=  0;
    r:=  MaxBuf - F;
    FillChar(Text_Buf^[0], r, ' ');
    len:=  0;
    Got:=  1;
    while (len < F) and (Got <> 0) do begin
      GetBlock(ct, Got);
      if Got <> 0 then begin
        Text_Buf^[r + len]:=  ct;
        INC(len);
      end;
    end;

    for i:= 1 to F do InsertNode(r - i);
    InsertNode(r);
    repeat
      if (match_length > len) then
        match_length:= len;
      if (match_length <= THRESHOLD) then
        begin
          match_length:= 1;
          EncodeChar(Text_Buf^[r]);
        end
      else
        begin
          EncodeChar(255 - THRESHOLD + match_length);
          EncodePosition(match_position);
        end;
      last_match_length:= match_length;
      i:= 0;
      Got:= 1;
      while (i < last_match_length) and (Got <> 0) do begin
        GetBlock(ct, Got);
        if Got <> 0 then begin
          DeleteNode(s);
          Text_Buf^[s]:= ct;
          if (s < PRED(F)) then
            Text_Buf^[s + MaxBuf]:= ct;
          s:= Succ(s) and Pred(MaxBuf);
          r:= Succ(r) and Pred(MaxBuf);
          InsertNode(r);
          inc(i);
        end;
      end;

      while (i < last_match_length) do begin
        INC(i);
        DeleteNode(s);
        s:= SUCC(s) AND PRED(MaxBuf);
        r:= SUCC(r) AND PRED(MaxBuf);
        DEC(len);
        if BOOLEAN(len) then InsertNode(r);
      end;
    until (len <= 0);

    if Boolean(putlen) then begin
      ct:= (putbuf SHR 8);
      PutBlock(ct, 1, Got);
      inc(codesize);
    end;

    PutBlock(OutBuf^, 0, Got);

    EndLZH;
end;

procedure TmdvLZH.LZHUnpack(AUnpackSize: DWord);
var c, i, j, k, r: SmallInt;
    c2: Byte;
    count: DWord;
    Put: Word;
begin
    InitLZH;
    StartHuff;
    r:= MaxBuf - F;
    FillChar(Text_Buf^[0], r,  ' ');
    Count:= 0;
    while count < AUnpackSize do begin
      c:= DecodeChar;
      if (c < 256) then begin
        c2:= Lo(c);
        PutBlock(c2, 1, Put);
        Text_Buf^[r]:= c;
        INC(r);
        r:= r and PRED(MaxBuf);
        INC(count);
      end
      else begin
        i:= (r - SUCC(DecodePosition)) and PRED(MaxBuf);
        j:= c - 255 + THRESHOLD;
        for k:= 0 to PRED(j) do begin
          c:= Text_Buf^[(i + k) and PRED(MaxBuf)];
          c2:= Lo(c);
          PutBlock(c2, 1, Put);
          Text_Buf^[r]:= c;
          INC(r);
          r:= r and Pred(MaxBuf);
          INC(count);
        end;
      end;
    end;
    PutBlock(OutBuf^, 0, Put);
    EndLZH;
end;

procedure TmdvLZH.GetBlock(var Target; var Actual_Bytes: Word);
var Temp: Word;
begin
    if (PosnG > Buf) or (PosnG + 1 > Succ(Buf)) then begin
      if PosnG > Buf then
        Buf:= FReadData(InBuf^, MaxBuf)
      else begin
        Move(InBuf^[PosnG], InBuf^[1], Buf-PosnG);
        Temp:= FReadData(InBuf^[Buf-PosnG], MaxBuf-(Buf-PosnG));
        Buf:= Buf-PosnG+Temp;
      end;
      if Buf = 0 then begin
        Actual_Bytes:= 0;
        Exit;
      end;
      PosnG:= 1;
    end;
    Move(InBuf^[PosnG], Target, 1);
    inc(PosnG, 1);
    if PosnG > SUCC(Buf) then Actual_Bytes:= 1 -(PosnG-SUCC(Buf))
    else Actual_Bytes:= 1;
end;

procedure TmdvLZH.PutBlock(var Source; NoBytes: Word; var Actual_Bytes: Word);
begin
    if NoBytes = 0 then begin
      FWriteData(OutBuf^, PRED(PosnP));
      Exit;
    end;
    if (PosnP > MaxBuf) OR (PosnP + NoBytes > SUCC(MaxBuf)) then begin
      FWriteData(OutBuf^, PRED(PosnP));
      PosnP:= 1;
    end;
    Move(Source, OutBuf^[PosnP], NoBytes);
    inc(PosnP, NoBytes);
    Actual_Bytes:= NoBytes;
end;


procedure TmdvLZH.InsertNode(r: SmallInt);
var tmp, i, p, cmp, c: SmallInt;
    key: PTextBuf;
begin
    cmp:= 1;
    key:= @Text_Buf^[r];
    p:= SUCC(MaxBuf) + key^[0];
    rSon^[r]:= MaxBuf;
    lSon^[r]:= MaxBuf;
    match_length:= 0;
    while match_length < F do begin
      if (cmp >= 0) then begin
        if (rSon^[p] <> MaxBuf) then p:= rSon^[p]
        else begin
          rSon^[p]:= r;
          Dad^[r]:= p;
          exit;
        end;
      end
      else begin
        if (lSon^[p] <> MaxBuf) then p:= lSon^[p]
        else begin
          lSon^[p]:= r;
          Dad^[r]:= p;
          exit;
        end;
      end;
      i:= 0;
      cmp:= 0;
      while (i < F) AND (cmp = 0) do begin
        inc(i);
        cmp:= key^[i] - Text_Buf^[p + i];
      end;
      if (i > THRESHOLD) then begin
        tmp:= PRED((r - p) and Pred(MaxBuf));
        if (i > match_length) then begin
          match_position:= tmp;
          match_length:= i;
        end;
        if (match_length < F) AND (i = match_length) then begin
          c:= tmp;
          if (c < match_position) then match_position:= c;
        end;
      end;
    end;
    Dad^[r]:= Dad^[p];
    lSon^[r]:= lSon^[p];
    rSon^[r]:= rSon^[p];
    Dad^[lSon^[p]]:= r;
    Dad^[rSon^[p]]:= r;
    if (rSon^[Dad^[p]] = p) then rSon^[Dad^[p]]:= r
    else lSon^[Dad^[p]]:= r;
    Dad^[p]:= MaxBuf;
end;

procedure TmdvLZH.DeleteNode(p: SmallInt);
var q: SmallInt;
begin
    if (Dad^[p] = MaxBuf) then exit;
    if (rSon^[p] = MaxBuf) then q:= lSon^[p]
    else
      if (lSon^[p] = MaxBuf) then q:= rSon^[p]
      else begin
        q:= lSon^[p];
        if (rSon^[q] <> MaxBuf) then begin
          repeat
            q:= rSon^[q];
          until (rSon^[q] = MaxBuf);
          rSon^[Dad^[q]]:= lSon^[q];
          Dad^[lSon^[q]]:= Dad^[q];
          lSon^[q]:= lSon^[p];
          Dad^[lSon^[p]]:= q;
        end;
        rSon^[q]:= rSon^[p];
        Dad^[rSon^[p]]:= q;
      end;
    Dad^[q]:= Dad^[p];
    if (rSon^[Dad^[p]] = p) then rSon^[Dad^[p]]:= q
    else lSon^[Dad^[p]]:= q;
    Dad^[p]:= MaxBuf;
end;

function TmdvLZH.GetBit: SmallInt;
var i: Byte;
    i2: SmallInt;
    Resultat: Word;
begin
    while (GetLen <= 8) do begin
      GetBlock(i, Resultat);
      if Resultat = 1 then i2:= i
      else i2:= 0;
      GetBuf:= GetBuf or (i2 shl (8 - GetLen));
      inc(GetLen, 8);
    end;
    i2:= GetBuf;
    GetBuf:= GetBuf shl 1;
    dec(GetLen);
    Result:= SmallInt((i2 < 0));
end;

function TmdvLZH.GetByte: SmallInt;
var j: Byte;
    i, Resultat: Word;
begin
    while (GetLen <= 8) do begin
      GetBlock(j, Resultat);
      if Resultat = 1 then i:= j
      else i:= 0;
      GetBuf:= GetBuf or (i shl (8 - GetLen));
      inc(GetLen, 8);
    end;
    i:= GetBuf;
    GetBuf:= GetBuf shl 8;
    dec(GetLen, 8);
    Result:= SmallInt(i shr 8);
end;

procedure TmdvLZH.PutCode(l: SmallInt; c: Word);
var Temp: Byte;
    Got: Word;
begin
    putbuf:= putbuf or (c shr putlen);
    inc(putlen, l);
    if (putlen >= 8) then begin
      Temp:= putbuf shr 8;
      PutBlock(Temp, 1, Got);
      DEC(putlen, 8);
      if (putlen  >= 8) then begin
        Temp:= Lo(PutBuf);
        PutBlock(Temp, 1, Got);
        inc(codesize, 2);
        DEC(putlen, 8);
        putbuf:= c shl (l - putlen);
      end
      else begin
        putbuf:= putbuf shl 8;
        inc(codesize);
      end;
    end;
end;

procedure TmdvLZH.StartHuff;
var i, j: SmallInt;
begin
    for i:= 0 to Pred(N_CHAR) do begin
      Freq^[i]:= 1;
      Son^[i]:= i + T;
      Prnt^[i + T]:= i;
    end;
    i:= 0;
    j:= N_CHAR;
    while (j <= R) do begin
      Freq^[j]:= Freq^[i] + Freq^[i + 1];
      Son^[j]:= i;
      Prnt^[i]:= j;
      Prnt^[i + 1]:= j;
      inc(i, 2);
      inc(j);
    end;
    Freq^[T]:= $ffff;
    Prnt^[R]:= 0;
end;

procedure TmdvLZH.Reconst;
var i, j, k, tmp: SmallInt;
    f, l: WORD;
begin
    j:= 0;
    for i:= 0 to PRED(T) do begin
      if (Son^[i] >= T) then begin
        Freq^[j]:= SUCC(Freq^[i]) div 2;
        Son^[j]:= Son^[i];
        INC(j);
      end;
    end;
    i:= 0;
    j:= N_CHAR;
    while (j < T) do begin
      k:= SUCC(i);
      f:= Freq^[i] + Freq^[k];
      Freq^[j]:= f;
      k:= PRED(j);
      while f < Freq^[k] do dec(K);
      inc(k);
      l:= (j - k) shl 1;
      tmp:= SUCC(k);
      move(Freq^[k], Freq^[tmp], l);
      Freq^[k]:= f;
      move(Son^[k], Son^[tmp], l);
      Son^[k]:= i;
      inc(i, 2);
      inc(j);
    end;
    for i:= 0 to pred(T) do begin
      k:= Son^[i];
      if (k >= T) then  Prnt^[k]:= i
      else begin
        Prnt^[k]:= i;
        Prnt^[SUCC(k)]:= i;
      end;
    end;
end;

procedure TmdvLZH.Update(c: SmallInt);
var i, j, l, k: Word;
begin
    if (Freq^[R] = MAX_Freq) then Reconst;
    c:= Prnt^[c + T];
    repeat
      INC(Freq^[c]);
      k:= Freq^[c];
      l:= SUCC(C);
      if (k > Freq^[l]) then begin
        while (k > Freq^[l]) do inc(l);
        dec(l);
        Freq^[c]:= Freq^[l];
        Freq^[l]:= k;
        i:= Son^[c];
        Prnt^[i]:= l;
        if (i < T) then Prnt^[SUCC(i)]:= l;
        j:= Son^[l];
        Son^[l]:= i;
        Prnt^[j]:= c;
        if (j < T) then Prnt^[SUCC(j)]:= c;
        Son^[c]:= j;
        c:= l;
      end;
      c:= Prnt^[c];
   until (c = 0);
end;

procedure TmdvLZH.EncodeChar(c: Word);
var i: WORD;
    j, k: SmallInt;
begin
    i:= 0;
    j:= 0;
    k:= Prnt^[c + T];
    repeat
      i:= i shr 1;
      if BOOLEAN(k and 1) then INC(i, $8000);
      INC(j);
      k:= Prnt^[k];
    until (k = R);
    Putcode(j, i);
    Update(c);
end;

procedure TmdvLZH.EncodePosition(c: Word);
var i, j: WORD;
begin
    i:= c shr 6;
    j:= p_code[i];
    Putcode(p_len[i], j shl 8);
    Putcode(6, (c and $3f) shl 10);
end;

function TmdvLZH.DecodeChar: SmallInt;
var c: Word;
begin
    c:= Son^[R];
    while (c < T) do begin
      c:= c + GetBit;
      c:= Son^[c];
    end;
    c:= c - T;
    Update(c);
    Result:= SmallInt(c);
end;

function TmdvLZH.DecodePosition: Word;
var i, j, c: Word;
begin
    i:= GetByte;
    c:= Word(d_code[i] shl 6);
    j:= d_len[i];
    dec(j, 2);
    while j <> 0 do begin
      i:= (i shl 1) + GetBit;
      dec(J);
    end;
    Result:= c or i and $3f;
end;

function TmdvLZH.ReadBlockStream(var ABuff; ACount: Dword): Dword;
begin
    Result:= FSource.Read(ABuff, ACount);
end;

function TmdvLZH.WriteBlockStream(var ABuff; ACount: Dword): Dword;
begin
    Result:= FDestination.Write(ABuff, ACount);
end;

end.