unit hiLZHComp;

interface

uses Kol,Share,Debug,KOLmdvLZH;

type
  THILZHComp = class(TDebug)
   private
   public
    _prop_FileName:string;
    _prop_NewFileName:string;

    _event_onResult:THI_Event;
    _event_onStreamResult:THI_Event;
    _data_FileName:THI_Event;
    _data_NewFileName:THI_Event;
    _data_Stream:THI_Event;

    procedure _work_doPack(var _Data:TData; Index:word);
    procedure _work_doUnpack(var _Data:TData; Index:word);
    procedure _work_doPackStream(var _Data:TData; Index:word);
    procedure _work_doUnpackStream(var _Data:TData; Index:word);
  end;

implementation

procedure THILZHComp._work_doPack;
var sfile,dfile:string;
begin
  sfile:=ReadString(_Data,_data_FileName,_prop_FileName);
  dfile:=ReadString(_Data,_data_NewFileName,_prop_NewFileName);
   if (FileExists(sfile)) then
    begin
     LZHPackFile(sfile,dfile);
      if (FileExists(dfile)) then _hi_OnEvent(_event_onResult,FileSize(dfile));
    end;
end;

procedure THILZHComp._work_doUnpack;
var sfile,dfile:string;
begin
  sfile:=ReadString(_Data,_data_FileName,_prop_FileName);
  dfile:=ReadString(_Data,_data_NewFileName,_prop_NewFileName);
   if (FileExists(sfile)) then
    begin
     LZHUnpackFile(sfile,dfile);
      if (FileExists(dfile)) then _hi_OnEvent(_event_onResult,FileSize(dfile));
    end;
end;

procedure THILZHComp._work_doPackStream;
var  st,dest:PStream;
     s:integer;
begin
   st := ReadStream(_data,_data_Stream,nil);
   if st <> nil then
    begin
     dest := NewMemoryStream;
     s := st.Size;
     dest.Write(s, SizeOf(s));
     st.Position:= 0;
     LZHPackStream(st, dest);
     _hi_OnEvent(_event_onStreamResult,dest);
     dest.Free;
    end;
end;

procedure THILZHComp._work_doUnpackStream;
var  st,dest:PStream;
     s:integer;
begin
   st := ReadStream(_data,_data_Stream,nil);
   if st <> nil then
    begin
     dest := NewMemoryStream;
     st.Position:= 0;
     st.Read(s, SizeOf(s));
     LZHUnpackStream(st,dest,s);
     _hi_OnEvent(_event_onStreamResult,dest);
     dest.Free;
    end;
end;

end.
